'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2006
' by Perpetual Motion Interactive Systems Inc. ( http://www.perpetualmotion.ca )
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'
Imports System.Threading
Imports System.Web.Mail

Imports DotNetNuke.Entities.Modules
Imports DotNetNuke.Security.Roles
Imports DotNetNuke.Services.FileSystem

Namespace DotNetNuke.Services.Mail

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' The SendBulkEMail Class is a helper class tht manages the sending of Email
    ''' </summary>
    ''' <remarks>
    ''' </remarks>
    ''' <history>
    ''' 	[cnurse]	9/13/2004	Updated to reflect design changes for Help, 508 support
    '''                       and localisation
    ''' </history>
    ''' -----------------------------------------------------------------------------
    Public Class SendBulkEmail

        Public Recipients As ArrayList
        Public Priority As MailPriority
        Public Subject As String
        Public BodyFormat As MailFormat
        Public Body As String
        Public Attachment As String
        Public SendMethod As String
        Public SMTPServer As String
        Public SMTPAuthentication As String
        Public SMTPUsername As String
        Public SMTPPassword As String
        Public Administrator As String
        Public Heading As String

        Public Sub New()

        End Sub

        Public Sub New(ByVal recipients As ArrayList, ByVal priority As String, ByVal format As String, ByVal portalAlias As String)

            Me.Recipients = recipients
            Select Case priority
                Case "1"
                    Me.Priority = MailPriority.High
                Case "2"
                    Me.Priority = MailPriority.Normal
                Case "3"
                    Me.Priority = MailPriority.Low
            End Select
            If format = "BASIC" Then
                Me.BodyFormat = MailFormat.Text
            Else
                Me.BodyFormat = MailFormat.Html
                ' Add Base Href for any images inserted in to the email.
                Me.Body = "<Base Href='" & portalAlias & "'>"
            End If

        End Sub

        Public Sub Send()
            Try

                Dim endDelimit As String
                'Use either vbCrLF or <br><br> depending on BodyFormat.
                If BodyFormat = MailFormat.Html Then
                    endDelimit = "<br>"
                Else
                    endDelimit = vbCrLf
                End If

                Dim strConfirmation As String
                strConfirmation = "Bulk Email Operation Started: " & Now().ToString & endDelimit & endDelimit

                ' send to recipients
                Dim strBody As String
                Dim intRecipients As Integer = 0
                Dim intMessages As Integer = 0
                Dim strDistributionList As String = ""
                Dim objRecipient As ListItem

                Select Case SendMethod
                    Case "TO"
                        For Each objRecipient In Recipients
                            If objRecipient.Text <> "" Then
                                intRecipients += 1
                                strBody = Heading & objRecipient.Value & "," & endDelimit & endDelimit & Body
                                Mail.SendMail(Administrator, objRecipient.Text, "", "", Priority, Subject, BodyFormat, System.Text.Encoding.UTF8, strBody, Attachment, SMTPServer, SMTPAuthentication, SMTPUsername, SMTPPassword)
                                intMessages += 1
                            End If
                        Next
                    Case "BCC"
                        For Each objRecipient In Recipients
                            If objRecipient.Text <> "" Then
                                intRecipients += 1
                                strDistributionList += "; " & objRecipient.Text
                            End If
                        Next
                        intMessages = 1
                        strBody = Body
                        Mail.SendMail(Administrator, "", "", strDistributionList, Priority, Subject, BodyFormat, System.Text.Encoding.UTF8, strBody, Attachment, SMTPServer, SMTPAuthentication, SMTPUsername, SMTPPassword)
                End Select

                ' send confirmation
                strConfirmation += "Email Recipients: " & intRecipients.ToString() & endDelimit
                strConfirmation += "Email Messages: " & intMessages.ToString() & endDelimit & endDelimit
                strConfirmation += "Bulk Email Operation Completed: " & Now().ToString & endDelimit
                Mail.SendMail(Administrator, Administrator, "", "", Priority, "Bulk Email Confirmation", BodyFormat, System.Text.Encoding.UTF8, strConfirmation, "", SMTPServer, SMTPAuthentication, SMTPUsername, SMTPPassword)

            Catch exc As Exception
                ' send mail failure
                System.Diagnostics.Debug.Write(exc.Message)
            End Try

        End Sub

    End Class

End Namespace
