'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2006
' by Perpetual Motion Interactive Systems Inc. ( http://www.perpetualmotion.ca )
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'

Imports System.IO
Imports System.Web.UI

Imports DotNetNuke.Common
Imports DotNetNuke.Common.Utilities
Imports DotNetNuke.Entities.Portals
Imports DotNetNuke.Security

Namespace DotNetNuke.HtmlEditor

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' The FTBInsertSmiley Class inserts a Smiley
    ''' </summary>
    ''' <remarks>
    ''' </remarks>
    ''' <history>
    ''' 	[cnurse]	01/27/2006  created
    ''' </history>
    ''' -----------------------------------------------------------------------------
    Public Class FTBInsertSmiley
        Inherits DotNetNuke.Framework.PageBase

        Protected WithEvents phHidden As System.Web.UI.WebControls.PlaceHolder
        Protected WithEvents lstSmileys As System.Web.UI.WebControls.DataList

        Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

            ' set page title
            Dim strTitle As String = PortalSettings.PortalName & " > Insert Smiley"
            Dim strSmileyPath As String
            Dim strSmileyMapPath As String

            ' show copyright credits?
            If GetHashValue(Common.Globals.HostSettings("Copyright"), "Y") = "Y" Then
                strTitle += " ( DNN " & PortalSettings.Version & " )"
            End If
            Title = strTitle

            Dim htmlhidden As New HtmlControls.HtmlInputHidden
            Dim _portalSettings As PortalSettings = PortalController.GetCurrentPortalSettings

            htmlhidden.ID = "TargetFreeTextBox"
            htmlhidden.Value = Request.Params("ftb")
            phHidden.Controls.Add(htmlhidden)

            'Get Host level Smileys
            strSmileyPath = Common.Globals.HostPath + "Smileys/"
            strSmileyMapPath = Common.Globals.HostMapPath + "Smileys\"

            Dim folder As DirectoryInfo = New DirectoryInfo(strSmileyMapPath)
            Dim arrFiles As FileInfo() = folder.GetFiles()
            lstSmileys.DataSource = arrFiles
            lstSmileys.DataBind()


        End Sub

        Public Function FormatUrl(ByVal Url As String) As String

            Return Common.Globals.HostPath + "Smileys/" + Url

        End Function

    End Class

End Namespace

