<%@ Page language="vb" Inherits="DotNetNuke.Modules.Gallery.PopupControls.PopupSelectMulti" CodeBehind="PopupSelectMulti.aspx.vb" AutoEventWireup="false" %>
<%@ Register TagPrefix="dnn" Namespace="DotNetNuke.Modules.Gallery.PopupControls" Assembly="DotNetNuke.Modules.Gallery.Popup" %>
<HTML>
	<HEAD>
		<title>Gallery Data Lookup</title>
		<META http-equiv="Content-Type" content="text/html; CHARSET=UTF-8">
		<LINK href="popup.css" type="text/css" rel="stylesheet">
			<script language="javascript" src="gallerypopup.js"></script>
			<script language="JavaScript"> 

		function applychanges()
		{
			window.returnValue = buildReturnValue( tblSelected.rows );			
			window.close();
		}

		function cancel()
		{
			var cancelItem = new popupCancel();
			window.returnValue = cancelItem;
			window.close();
		}

		function window.onload()
		{
			appendExistingItems();
			if ( !checkMode( _mode, LookupBrowse ) )
			{
				findValue.focus();
			}
		}

		function appendExistingItems()
		{
			var args = this.dialogArguments;
			if ( args == null ) return;
			if ( args.items == null ) return;
			var items = args.items;

			var len = items.length;
			for ( var i = 0; i < len; i++ )
			{
				var item = items[i];
				appendItem( item.getAttribute("oid"), item.getAttribute("olocation"), item.getAttribute("otype"), item.innerHTML )
			}
			setNavigationState();
		}

		function resultsReady()
		{
			if ( frmResults.document.readyState == "complete" )
			{
				document.body.style.cursor = "auto";

				if ( !checkMode( _mode, LookupBrowse ) )
				{
					btnGo.disabled = false;
				}

				setNavigationState();
			}
		}

		function removeSelected()
		{
			var items = tblSelected.selectedItems;
			for ( var i = 0; i < items.length; i++ )
			{
				items[i].removeNode( true )
			}

			items.splice( 0, items.length );

			if ( tblSelected.rows.length > 0 )
			{
				selectItem( tblSelected, tblSelected.rows[0], true );
			}

			setNavigationState();
		}

		function duplicateSelection( oid )
		{
			var len = tblSelected.rows.length;
			for ( var i = 0; i < len; i++ )
			{
				if ( tblSelected.rows[i].oid == oid )
				{
					return true;
				}
			}
			return false;
		}

		function appendItem( id, location, type, html )
		{
			var tr		= tblSelected.insertRow();
			tr.oid		= id;
			tr.olocation = location;
			tr.otype	= type;

			var td	= tr.insertCell();
			td.className	= "sel";
			td.noWrap		= true;
			td.innerHTML	= html;

			if ( tr.rowIndex == 0 )
			{
				selectItem( tblSelected, tr, false );
			}
		}
		
		function appendSelected()
		{
			if (frmResults.tblResults == undefined)
			{
				return;
			}

			var items = frmResults.tblResults.selectedItems;
			if ( items )
			{
				var len	= items.length;

				for ( var i = 0; i < len; i++ )
				{
					var o = items[i];
					
					if ( !duplicateSelection( o.oid ) )
					{
						appendItem( o.oid, o.olocation, o.otype, o.firstChild.innerHTML );
					}
				}

				setNavigationState();
			}
		}

		function setNavigationState()
		{
			if (frmResults.tblResults != undefined)
			{				
				btnAppend.disabled = ( frmResults.tblResults.rows.length == 0 );				
				tblNoRecords.runtimeStyle.display = ( tblSelected.rows.length == 0 ? "" : "none" );
			}
			if (tblSelected != undefined)
			{
				btnRemove.disabled = ( tblSelected.rows.length == 0 );
			}
		}
			</script>
	</HEAD>
	<body>
		<table style="WIDTH: 100%; HEIGHT: 100%" cellSpacing="0" cellPadding="0">
			<tbody>
				<tr>
					<td colSpan="2">
						<div class="Main">
							<div id="divSearch">
								<table height="100%" cellSpacing="0" cellPadding="0" width="100%">
									<tbody>
										<tr>
											<td class="Search">
												<dnn:PopupSearch id="ctlSearch" runat="server"></dnn:PopupSearch>
											</td>
										</tr>
										<tr>
											<td>
												<table id="tblFind" height="100%" cellSpacing="0" cellPadding="0" width="100%">
													<tbody>
														<tr>
															<td width="100%">
																<iframe id="frmResults" onreadystatechange="resultsReady()" tabIndex="4" scrolling="no"
																	height="100%" width="100%"></iframe>
															</td>
														</tr>
														<tr>
															<td align="right" height="24" width="100%">
																<button id="btnAppend" title="Add the selected record" style="WIDTH: 100px" disabled onclick="appendSelected()"
																	tabIndex="5" type="button">Add</button>&nbsp;
																<button id="btnRemove" title="Remove the selected record" style="WIDTH: 100px" disabled
																	onclick="removeSelected();" tabIndex="6" type="button">Remove</button>&nbsp;
															</td>
														</tr>
														<tr>
															<td>
																<div class="Objects" id="rtnObjList">
																	<table id="tblSelected" hideFocus onkeydown="listKeyDown(this)" ondblclick="removeSelected()"
																		onclick="clickItem( this )" tabIndex="7" cellSpacing="0" cellPadding="2" width="100%">
																		<tbody></tbody></table>
																	<table class="Message" id="tblNoRecords">
																		<tbody>
																			<tr>
																				<td class="Message" align="center">Select records...</td>
																			</tr>
																		</tbody>
																	</table>
																</div>
															</td>
														</tr>
													</tbody>
												</table>
											</td>
										</tr>
									</tbody>
								</table>
							</div>
						</div>
						<div id="divFill" style="DISPLAY: none; FILTER: progid: DXImageTransform.Microsoft.Gradient(GradientType=0, StartColorStr=#00ff00, EndColorStr=#00cc00); LEFT: 20px; WIDTH: 0px; POSITION: absolute; TOP: 80px; HEIGHT: 1px"></div>
					</td>
				</tr>
				<tr>
					<td class="Footer" colspan="2" align="right" height="20">&nbsp;
						<button id="butBegin" onclick="applychanges();" type="button">OK</button>&nbsp;
						<button id="cmdDialogCancel" onclick="cancel();" type="button">Cancel</button></td>
				</tr>
			</tbody>
		</table>
	</body>
</HTML>
